clear all
warning off
%
%	Minimializace cx pro Ax = b & x >= 0
%	m		pocet radku matice A
%	n		pocet sloupcu matice A
%	B_ind	index bazovych vektoru
%	N_ind	index nebazovych vektoru
%	bfs 	vstupni pripustne reseni

c=[c1 c2 .. cm];
A=[a11 a12 .. a1n; .. ; am1 am2 .. amn];
b=[b1 b2 .. bn]';
eps1=0.000;

%	hledani vsech pripustnych reseni

[m n] = size(A);
bfs_all=[];                             %	indexy bazi vsech pripustnych reseni
d_all=[];                               %	vsechna pripustna reseni
pom=0;
if (n>=m)
    komb=nchoosek(1:n,m);               %	vsechny kombinace bazi
    Nkomb=nchoosek(n,m);                %	pocet kombinaci bazi
    for i=1:Nkomb
      d = inv(A(:,komb(i,:))) * b;      %	bazova cast vektoru krajnich bodu mnoziny (bez dolnich omezeni)
      if all( d>=0 & d~=Inf & d~=-Inf ) %	kriterium pripustnosti reseni
       pom=pom+1;   
       bfs_all(pom,:)=komb(i,:);
       d_all(pom,:)=d;
      end 
    end    
else  
  error ('Pocet rovnic je vetsi nez pocet promennych');
end
if isempty(bfs_all)
  error ('Uloha nema reseni');
end
bfs=zeros(1,n);
bfs(bfs_all(4,:))=1;         %	dosad nejake pripustne reseni

% Simplexova metoda cykluje dokud neni nalezeno optimum nebo reseni
% neexistuje

B_ind = find(bfs);
N_ind = find(ones(1,n) - abs(sign(bfs)));
iters=0;
while 1==1

iters=iters+1;
Binv = inv(A(:,B_ind));     %	inverze bazove submatice
d = Binv * b;               %	bazova cast vektoru krajnich bodu mnoziny pripustnych reseni

c_mod = zeros(1,n);                                             %	c_mod		modifikovany vektor cen ulohy
c_mod(:,N_ind) = c(:,N_ind) - c(:,B_ind) * Binv * A(:,N_ind);   %	c_mod = c_N - c_B * B^-1 * AN
% cj minimalni cena ulohy pro nebazove promenne
% j j-ty sloupec matice A odpovidajici minimalni cene ulohy (kandidat na novou bazovou promennou)

[cj j]=min(c_mod);

% pokud cj >= 0 , jsou tim i vsechna c >= 0 => zvetsovanim jakekoli nebazove promenne zvysim hodnotu kriteria
% reseni je v optimu

if ((cj >= -eps1))
  reseni = zeros(n,1);
  reseni(B_ind,:) = d;
  return;
  end;

%	neni-li tomu tak, bude j-ta promenna v pristim cyklu bazova promenna
%	w = B^-1 * a[j]		pomerny vahovy vektor sloupce vstupujiciho do baze

w = Binv * A(:,j);

%	Hledam bazovou promennou, ktera by mela naopak bazi opustit
%	Bude to takova i-ta promenna, pro kterou bude platit w[i]>0 pricemz
%	podil d[i]/w[i] bude minimalni
%	vymena sloupce j do baze a sloupce i z baze

i=0;

zz = find (w > eps1)' ;
[yy, ii] = min (d(zz) ./ w (zz)) ;
i = zz(ii(1)) ;

if (i == 0)
  error ('Uloha nema reseni');
end;

k = B_ind(i);
B_ind(i) = j;
N_ind(j == N_ind) = k;
[i j]

end;	% while


